<?php

/**
 * 20/10/2015
 * @author Victor Novy
 */

namespace Teknisa\EST\Controllers;

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Request\Row;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;

class LanctoestoqController extends \Teknisa\Libs\Controller\CRUD {
    
	private $newCode;
    protected $environment;
	
    public function __construct($crudService, $environment, $newCode) {
        parent::__construct($crudService, $environment);
        $this->environment = $environment;
        $this->newCode = $newCode;
    }
    
	/**
     *
     * @param Row $request
     * @param Response $response
     */
    public function save(DTO\Request $request, DTO\Response $response) {
        $lancamento = $request->getRow(); 
        $nrlancestq = (isset($lancamento['NRLANCESTQ']) && $lancamento['NRLANCESTQ'] !=null)?$lancamento['NRLANCESTQ']:$this->newCode->getCodeByTableName('LANCTOEST'.$lancamento->get('CDFILIAL'), $this->environment->getNrOrgTrab());
        $itens = $lancamento->get('ITENS');
        $lancamento->remove('ITENS');
        $lancamento->set('NRLANCESTQ', $nrlancestq);
        if($lancamento['__is_new']){
            $requestLanctoestoq = new Row($lancamento, '/crud/lanctoestoq/save', 'POST', $request->getUserId());
            $requestLanctoestoq->setParameter('dbname', 'lanctoestoq');
            parent::save($requestLanctoestoq, $response);
        }

        foreach ($itens as $key => $item) {
            $itens[$key]['NRLANCESTQ'] = $nrlancestq;
            $requestItlanctoest = new Row($itens[$key], '/crud/lanctoestoq/save', 'POST',$request->getUserId());
            $requestItlanctoest->setParameter('dbname','itlanctoest');
            parent::save($requestItlanctoest, $response);
        }
        $lancamento['ITENS'] = $itens;
        $response->addDataSet(new DataSet('/lanctoestoq/save', $lancamento->getArrayCopy()));
        
    }
}